Loading...
1#!/bin/bash
2# SPDX-License-Identifier: GPL-2.0
3# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
4#set -x
5
6usage() {
7 echo "Usage:"
8 echo " $0 -r <release> | <vmlinux> [<base path>|auto] [<modules path>]"
9}
10
11if [[ $1 == "-r" ]] ; then
12 vmlinux=""
13 basepath="auto"
14 modpath=""
15 release=$2
16
17 for fn in {,/usr/lib/debug}/boot/vmlinux-$release{,.debug} /lib/modules/$release{,/build}/vmlinux ; do
18 if [ -e "$fn" ] ; then
19 vmlinux=$fn
20 break
21 fi
22 done
23
24 if [[ $vmlinux == "" ]] ; then
25 echo "ERROR! vmlinux image for release $release is not found" >&2
26 usage
27 exit 2
28 fi
29else
30 vmlinux=$1
31 basepath=${2-auto}
32 modpath=$3
33 release=""
34 debuginfod=
35
36 # Can we use debuginfod-find?
37 if type debuginfod-find >/dev/null 2>&1 ; then
38 debuginfod=${1-only}
39 fi
40
41 if [[ $vmlinux == "" && -z $debuginfod ]] ; then
42 echo "ERROR! vmlinux image must be specified" >&2
43 usage
44 exit 1
45 fi
46fi
47
48declare -A cache
49declare -A modcache
50
51find_module() {
52 if [[ -n $debuginfod ]] ; then
53 if [[ -n $modbuildid ]] ; then
54 debuginfod-find debuginfo $modbuildid && return
55 fi
56
57 # Only using debuginfod so don't try to find vmlinux module path
58 if [[ $debuginfod == "only" ]] ; then
59 return
60 fi
61 fi
62
63 if [[ "$modpath" != "" ]] ; then
64 for fn in $(find "$modpath" -name "${module//_/[-_]}.ko*") ; do
65 if readelf -WS "$fn" | grep -qwF .debug_line ; then
66 echo $fn
67 return
68 fi
69 done
70 return 1
71 fi
72
73 modpath=$(dirname "$vmlinux")
74 find_module && return
75
76 if [[ $release == "" ]] ; then
77 release=$(gdb -ex 'print init_uts_ns.name.release' -ex 'quit' -quiet -batch "$vmlinux" 2>/dev/null | sed -n 's/\$1 = "\(.*\)".*/\1/p')
78 fi
79
80 for dn in {/usr/lib/debug,}/lib/modules/$release ; do
81 if [ -e "$dn" ] ; then
82 modpath="$dn"
83 find_module && return
84 fi
85 done
86
87 modpath=""
88 return 1
89}
90
91parse_symbol() {
92 # The structure of symbol at this point is:
93 # ([name]+[offset]/[total length])
94 #
95 # For example:
96 # do_basic_setup+0x9c/0xbf
97
98 if [[ $module == "" ]] ; then
99 local objfile=$vmlinux
100 elif [[ "${modcache[$module]+isset}" == "isset" ]]; then
101 local objfile=${modcache[$module]}
102 else
103 local objfile=$(find_module)
104 if [[ $objfile == "" ]] ; then
105 echo "WARNING! Modules path isn't set, but is needed to parse this symbol" >&2
106 return
107 fi
108 modcache[$module]=$objfile
109 fi
110
111 # Remove the englobing parenthesis
112 symbol=${symbol#\(}
113 symbol=${symbol%\)}
114
115 # Strip segment
116 local segment
117 if [[ $symbol == *:* ]] ; then
118 segment=${symbol%%:*}:
119 symbol=${symbol#*:}
120 fi
121
122 # Strip the symbol name so that we could look it up
123 local name=${symbol%+*}
124
125 # Use 'nm vmlinux' to figure out the base address of said symbol.
126 # It's actually faster to call it every time than to load it
127 # all into bash.
128 if [[ "${cache[$module,$name]+isset}" == "isset" ]]; then
129 local base_addr=${cache[$module,$name]}
130 else
131 local base_addr=$(nm "$objfile" 2>/dev/null | awk '$3 == "'$name'" && ($2 == "t" || $2 == "T") {print $1; exit}')
132 if [[ $base_addr == "" ]] ; then
133 # address not found
134 return
135 fi
136 cache[$module,$name]="$base_addr"
137 fi
138 # Let's start doing the math to get the exact address into the
139 # symbol. First, strip out the symbol total length.
140 local expr=${symbol%/*}
141
142 # Now, replace the symbol name with the base address we found
143 # before.
144 expr=${expr/$name/0x$base_addr}
145
146 # Evaluate it to find the actual address
147 expr=$((expr))
148 local address=$(printf "%x\n" "$expr")
149
150 # Pass it to addr2line to get filename and line number
151 # Could get more than one result
152 if [[ "${cache[$module,$address]+isset}" == "isset" ]]; then
153 local code=${cache[$module,$address]}
154 else
155 local code=$(${CROSS_COMPILE}addr2line -i -e "$objfile" "$address" 2>/dev/null)
156 cache[$module,$address]=$code
157 fi
158
159 # addr2line doesn't return a proper error code if it fails, so
160 # we detect it using the value it prints so that we could preserve
161 # the offset/size into the function and bail out
162 if [[ $code == "??:0" ]]; then
163 return
164 fi
165
166 # Strip out the base of the path on each line
167 code=$(while read -r line; do echo "${line#$basepath/}"; done <<< "$code")
168
169 # In the case of inlines, move everything to same line
170 code=${code//$'\n'/' '}
171
172 # Replace old address with pretty line numbers
173 symbol="$segment$name ($code)"
174}
175
176debuginfod_get_vmlinux() {
177 local vmlinux_buildid=${1##* }
178
179 if [[ $vmlinux != "" ]]; then
180 return
181 fi
182
183 if [[ $vmlinux_buildid =~ ^[0-9a-f]+ ]]; then
184 vmlinux=$(debuginfod-find debuginfo $vmlinux_buildid)
185 if [[ $? -ne 0 ]] ; then
186 echo "ERROR! vmlinux image not found via debuginfod-find" >&2
187 usage
188 exit 2
189 fi
190 return
191 fi
192 echo "ERROR! Build ID for vmlinux not found. Try passing -r or specifying vmlinux" >&2
193 usage
194 exit 2
195}
196
197decode_code() {
198 local scripts=`dirname "${BASH_SOURCE[0]}"`
199
200 echo "$1" | $scripts/decodecode
201}
202
203handle_line() {
204 if [[ $basepath == "auto" && $vmlinux != "" ]] ; then
205 module=""
206 symbol="kernel_init+0x0/0x0"
207 parse_symbol
208 basepath=${symbol#kernel_init (}
209 basepath=${basepath%/init/main.c:*)}
210 fi
211
212 local words
213
214 # Tokenize
215 read -a words <<<"$1"
216
217 # Remove hex numbers. Do it ourselves until it happens in the
218 # kernel
219
220 # We need to know the index of the last element before we
221 # remove elements because arrays are sparse
222 local last=$(( ${#words[@]} - 1 ))
223
224 for i in "${!words[@]}"; do
225 # Remove the address
226 if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
227 unset words[$i]
228 fi
229
230 # Format timestamps with tabs
231 if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
232 unset words[$i]
233 words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
234 fi
235 done
236
237 if [[ ${words[$last]} =~ ^[0-9a-f]+\] ]]; then
238 words[$last-1]="${words[$last-1]} ${words[$last]}"
239 unset words[$last]
240 last=$(( $last - 1 ))
241 fi
242
243 if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
244 module=${words[$last]}
245 module=${module#\[}
246 module=${module%\]}
247 modbuildid=${module#* }
248 module=${module% *}
249 if [[ $modbuildid == $module ]]; then
250 modbuildid=
251 fi
252 symbol=${words[$last-1]}
253 unset words[$last-1]
254 else
255 # The symbol is the last element, process it
256 symbol=${words[$last]}
257 module=
258 modbuildid=
259 fi
260
261 unset words[$last]
262 parse_symbol # modifies $symbol
263
264 # Add up the line number to the symbol
265 echo "${words[@]}" "$symbol $module"
266}
267
268while read line; do
269 # Let's see if we have an address in the line
270 if [[ $line =~ \[\<([^]]+)\>\] ]] ||
271 [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
272 # Translate address to line numbers
273 handle_line "$line"
274 # Is it a code line?
275 elif [[ $line == *Code:* ]]; then
276 decode_code "$line"
277 # Is it a version line?
278 elif [[ -n $debuginfod && $line =~ PID:\ [0-9]+\ Comm: ]]; then
279 debuginfod_get_vmlinux "$line"
280 else
281 # Nothing special in this line, show it as is
282 echo "$line"
283 fi
284done
1#!/bin/bash
2# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
3#set -x
4
5if [[ $# < 2 ]]; then
6 echo "Usage:"
7 echo " $0 [vmlinux] [base path] [modules path]"
8 exit 1
9fi
10
11vmlinux=$1
12basepath=$2
13modpath=$3
14declare -A cache
15declare -A modcache
16
17parse_symbol() {
18 # The structure of symbol at this point is:
19 # ([name]+[offset]/[total length])
20 #
21 # For example:
22 # do_basic_setup+0x9c/0xbf
23
24 if [[ $module == "" ]] ; then
25 local objfile=$vmlinux
26 elif [[ "${modcache[$module]+isset}" == "isset" ]]; then
27 local objfile=${modcache[$module]}
28 else
29 [[ $modpath == "" ]] && return
30 local objfile=$(find "$modpath" -name $module.ko -print -quit)
31 [[ $objfile == "" ]] && return
32 modcache[$module]=$objfile
33 fi
34
35 # Remove the englobing parenthesis
36 symbol=${symbol#\(}
37 symbol=${symbol%\)}
38
39 # Strip the symbol name so that we could look it up
40 local name=${symbol%+*}
41
42 # Use 'nm vmlinux' to figure out the base address of said symbol.
43 # It's actually faster to call it every time than to load it
44 # all into bash.
45 if [[ "${cache[$module,$name]+isset}" == "isset" ]]; then
46 local base_addr=${cache[$module,$name]}
47 else
48 local base_addr=$(nm "$objfile" | grep -i ' t ' | awk "/ $name\$/ {print \$1}" | head -n1)
49 cache[$module,$name]="$base_addr"
50 fi
51 # Let's start doing the math to get the exact address into the
52 # symbol. First, strip out the symbol total length.
53 local expr=${symbol%/*}
54
55 # Now, replace the symbol name with the base address we found
56 # before.
57 expr=${expr/$name/0x$base_addr}
58
59 # Evaluate it to find the actual address
60 expr=$((expr))
61 local address=$(printf "%x\n" "$expr")
62
63 # Pass it to addr2line to get filename and line number
64 # Could get more than one result
65 if [[ "${cache[$module,$address]+isset}" == "isset" ]]; then
66 local code=${cache[$module,$address]}
67 else
68 local code=$(addr2line -i -e "$objfile" "$address")
69 cache[$module,$address]=$code
70 fi
71
72 # addr2line doesn't return a proper error code if it fails, so
73 # we detect it using the value it prints so that we could preserve
74 # the offset/size into the function and bail out
75 if [[ $code == "??:0" ]]; then
76 return
77 fi
78
79 # Strip out the base of the path
80 code=${code//$basepath/""}
81
82 # In the case of inlines, move everything to same line
83 code=${code//$'\n'/' '}
84
85 # Replace old address with pretty line numbers
86 symbol="$name ($code)"
87}
88
89decode_code() {
90 local scripts=`dirname "${BASH_SOURCE[0]}"`
91
92 echo "$1" | $scripts/decodecode
93}
94
95handle_line() {
96 local words
97
98 # Tokenize
99 read -a words <<<"$1"
100
101 # Remove hex numbers. Do it ourselves until it happens in the
102 # kernel
103
104 # We need to know the index of the last element before we
105 # remove elements because arrays are sparse
106 local last=$(( ${#words[@]} - 1 ))
107
108 for i in "${!words[@]}"; do
109 # Remove the address
110 if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
111 unset words[$i]
112 fi
113
114 # Format timestamps with tabs
115 if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
116 unset words[$i]
117 words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
118 fi
119 done
120
121 if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
122 module=${words[$last]}
123 module=${module#\[}
124 module=${module%\]}
125 symbol=${words[$last-1]}
126 unset words[$last-1]
127 else
128 # The symbol is the last element, process it
129 symbol=${words[$last]}
130 module=
131 fi
132
133 unset words[$last]
134 parse_symbol # modifies $symbol
135
136 # Add up the line number to the symbol
137 echo "${words[@]}" "$symbol $module"
138}
139
140while read line; do
141 # Let's see if we have an address in the line
142 if [[ $line =~ \[\<([^]]+)\>\] ]] ||
143 [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
144 # Translate address to line numbers
145 handle_line "$line"
146 # Is it a code line?
147 elif [[ $line == *Code:* ]]; then
148 decode_code "$line"
149 else
150 # Nothing special in this line, show it as is
151 echo "$line"
152 fi
153done